#include "Audio.h"

Audio::Audio(void)
{
	m_Loader = NULL;
	m_Performance = NULL;
}//cons

Audio::~Audio(void)
{
}//desc

void Audio::init ( void )
{
	CoInitialize(NULL); //initialize COM

	CoCreateInstance(CLSID_DirectMusicLoader,
					 NULL,
					 CLSCTX_INPROC,
					 IID_IDirectMusicLoader8,
					 (void**)&m_Loader); //create loader object

	CoCreateInstance(CLSID_DirectMusicPerformance,
					 NULL,
					 CLSCTX_INPROC,
					 IID_IDirectMusicPerformance8,
					 (void**)&m_Performance); //create performance object

	m_Performance->InitAudio(NULL,
							  NULL,
							  NULL,
							  DMUS_APATH_DYNAMIC_STEREO,
							  64,
							  DMUS_AUDIOF_ALL,
							  NULL); //initialize DirectMusic & DirectSound

	WCHAR wszSearchPath[MAX_PATH];

	MultiByteToWideChar(CP_ACP,0,".\0",-1,wszSearchPath,MAX_PATH);

	m_Loader->SetSearchDirectory(GUID_DirectMusicAllTypes,wszSearchPath,false);

//	setVolume(500L);
}// init


void Audio::release ( void )
{
	m_Loader->Release		();

	m_Performance->Stop		( NULL, NULL, 0, 0 );
	m_Performance->CloseDown();
	m_Performance->Release	();

	CoUninitialize();
	
}// release


void Audio::setVolume		( long p_Vol )
{
	m_Performance->SetGlobalParam	(
										GUID_PerfMasterVolume,
										&p_Vol,
										sizeof(long)
									); //set volume
}// setVolume



long Audio::getVolume		( void )
{
	long retVolume = 0L;
	m_Performance->GetGlobalParam	(
										GUID_PerfMasterVolume,
										&retVolume,
										sizeof(long)
									);	//get volume

	return retVolume;

}// getVolume

Audio* ms_Instance = NULL;

Audio* Audio::getSingleton	()
{
	if ( !ms_Instance )
	{
		ms_Instance = new Audio();
		ms_Instance->init();
	}
	return ms_Instance;
}