#include "ExplosionLayout.h"

ExplosionLayout::ExplosionLayout(unsigned int p_NumOfParticles,
									D3DXMATRIX* wM, float p_LifeLength, 
									float p_SizeOfParticle, D3DXCOLOR& p_Color, string& p_TextureName)
:ParticleGroupLayout(p_NumOfParticles, p_LifeLength, p_SizeOfParticle, p_Color, p_TextureName)
{
	this->wM = wM;
	m_LastRun = 0;
	m_CreateRectengle = false;
}

ExplosionLayout::~ExplosionLayout(void)
{
}
void ExplosionLayout::initParticles		(Particle ***particles)
{

#ifdef	DEBUG_LEVEL_1
	if((*particles) == NULL)
	{
		Tools::LOG("ExplosionLayout::initParticles @ (*particles) == NULL ");
		return;
	}
#endif

	m_LastRun = 0;
	Particle *particle;

	for( int i = 0 ; i < m_NumOfParticles ; i++ )
	{		
		//D3DXVECTOR3 t(Tools::rnd(-2.0f,2.0f),Tools::rnd(1.0f,3.0f),Tools::rnd(-2.0f,2.0f));
		particle = (*particles)[i];
		particle->m_IsAlive = true;
		particle->m_Color = m_Color;
		particle->m_Position.x = wM->_41;
		particle->m_Position.y = wM->_42;
		particle->m_Position.z = wM->_43;
		particle->m_Velocity.x = Tools::rnd(-2.0f,2.0f);
		particle->m_Velocity.y = Tools::rnd(1.0f,3.0f);
		particle->m_Velocity.z = Tools::rnd(-2.0f,2.0f);
		//= t;//D3DXVECTOR3(15.0f * cosf(angle),15.0f * wM->_21 ,15.0f * sinf(angle));
	}
}



void ExplosionLayout::updateParticles	(Particle ***particles)
{
	if( timeGetTime() - m_LastRun < 10.0f )
		return;
	m_LastRun = timeGetTime();
	for( int i = 0 ; i < m_NumOfParticles ; i++ )
	{		
//		(*particles)[i]->m_Velocity += D3DXVECTOR3(0,-.09f,0);
		(*particles)[i]->m_Velocity.y -= 0.01f;
//		(*particles)[i]->m_C
		(*particles)[i]->m_Color.r *= 1.05f; ;
		(*particles)[i]->m_Color.g *= 1.02f; ;
		(*particles)[i]->m_Color.b /= 1.04f; ;

		(*particles)[i]->m_Position += (*particles)[i]->m_Velocity ;
		//(*particles)[i]->m_Position += (*particles)[i]->m_Velocity;
	}
}
