#pragma once
#include "listener.h"

class FrameListener :
	public virtual Listener
{
public:
	FrameListener		(void);	// default priority is 1
	FrameListener		(unsigned int p_Priority);
	~FrameListener		(void){};
	bool isFrameListener()	{return true;};

	virtual bool frameStarted	( float timeElapsed)	{return true;};	// this function will be called 
																		// just before frame starts

	virtual bool frameEnded		( float timeElapsed)	{return true;};	// this function will be called 
																		// just after frame ends

	float lastFrameStartedEventTime;	// previous frameStarted call time  
	float firstFrameStartedEventTime;	// first frameStarted call time  

	float lastFrameEndedEventTime;		// previous frameEnded call time  
	float firstFrameEndedEventTime;		// first frameEnded call time  

public:
	unsigned int			m_Priority;		// defines per how many frames this frame listener will be called
											// if 1 every frame, if 10 every 10 frames
	unsigned int			m_ID;			

};
