#include "GameControlListener.h"
#include "Tools.h"
#include "GameStats.h"


GameControlListener::GameControlListener( SpaceShip *p_Renderable,Camera *p_Camera, ParticleGroupLayout *pgl  )
{
	m_SpaceShip = p_Renderable;

	m_Camera = p_Camera;

	m_NextDestination = m_SpaceShip->getPosition();

	m_Priority = 1;

	m_LastRun = 0;

	m_gameSound = Sound::getSound("spacewind");
	m_gameSound->setRepeats(1000);
	m_gameSound->play();
	m_gameSound->get3DBuffer()->SetMinDistance(100,DS3D_IMMEDIATE);
	m_gameSound->get3DBuffer()->SetMaxDistance(1000,DS3D_IMMEDIATE);

}

GameControlListener::~GameControlListener(void)
{

}

bool GameControlListener::keyPressed	( Keyboard		*p_Keyboard, float timeElapsed) 
{

	return true;
}


bool GameControlListener::keyReleased	( Keyboard		*p_Keyboard, float timeElapsed) 
{

	return true;
}

bool GameControlListener::mouseButtonReleased	( MouseState	&p_MouseEvent, float timeElapsed) 
{

	if ( p_MouseEvent.buttons & MOUSE_Middle)
	{

	}
	if ( p_MouseEvent.buttons & MOUSE_Left)
	{

	}
	if ( p_MouseEvent.buttons & MOUSE_Right)
	{
		
		if( m_SpaceShip->m_Gun[1]->isReadyToFire() )
		{
			m_SpaceShip->m_Gun[1]->fire( (m_Camera->mPosW - m_SpaceShip->getPosition()) , ((m_NextDestination - m_SpaceShip->getPosition()) * m_SpaceShip->m_Speed) );
			GameStats::getSingleton()->addPoints(-10);
		}

	}
	return true;
}

DWORD lastAtack = 0;
bool GameControlListener::mouseButtonPressed	( MouseState	&p_MouseEvent, float timeElapsed) 
{
	if( p_MouseEvent.buttons & MOUSE_Left && m_SpaceShip->m_Gun[0]->isReadyToFire() )
	{
		m_SpaceShip->m_Gun[0]->fire( (m_Camera->mPosW - m_SpaceShip->getPosition()) , ((m_NextDestination - m_SpaceShip->getPosition()) * m_SpaceShip->m_Speed) );
		GameStats::getSingleton()->addPoints(-1);
	}

	return true;
}
D3DXVECTOR3 tmpV(0.0f,0.0f,0.0f);
float sumXRot = 0;
bool GameControlListener::mouseMoved			( MouseState	&p_MouseEvent, float timeElapsed) 
{
	m_SpaceShip->m_Gun[0]->m_GunLayout->m_SpreadFactor += p_MouseEvent.z / 240.0f;

	m_NextDestination += D3DXVECTOR3( (float)p_MouseEvent.x,0,-(float)p_MouseEvent.y);
	if( m_NextDestination.x > 150.0f )
	{
		m_NextDestination.x = 150.0f;
	}
	else if( m_NextDestination.x < -150.0f )
	{
		m_NextDestination.x = -150.0f;
	}	
	if( m_NextDestination.z > 150.0f )
	{
		m_NextDestination.z = 150.0f;
	}
	else if( m_NextDestination.z < -150.0f )
	{
		m_NextDestination.z = -150.0f;
	}
	D3DXVECTOR3	posV = m_SpaceShip->getPosition();
	D3DXVECTOR3	distV = m_NextDestination - posV;
//	D3DXVec3Normalize(&posV,&distV);

	m_SpaceShip->rotateZ( distV.x / 45.0f);
	//if(distV.z < 0.0f)
	//	m_SpaceShip->rotateAbsoluteX( 15.0f );
	//else if(distV.z > 0.0f)
	//	m_SpaceShip->rotateAbsoluteX( -15.0f );
	return true;
}

bool GameControlListener::frameStarted		( float timeElapsed) 
{
	if( float(timeGetTime()) - m_LastRun > 20 )
	{
		D3DXVECTOR3	posV ( m_SpaceShip->getPosition() );
		D3DXVECTOR3	distV ( m_NextDestination - posV );
		float distSQ =  Tools::getVectorLengthSQ( distV );
		if ( distSQ > 10.0f)
		{

			distV /= 300.0f ;
			distV *= m_SpaceShip->m_Speed;
			D3DXVECTOR3	distV2(distV);
			float z = (posV.z+90.0f)*0.6;
			if (posV.x + distV.x < -100.0f)
				distV2.x = -100.0f - posV.x;
			else if (posV.x + distV.x > 100.0f)
				distV2.x =  100.0f - posV.x;
			if (posV.z + distV.z < -80.0f)
				distV2.z = -80.0f - posV.z;
			else if (posV.z + distV.z > 120.0f)
				distV2.z = 120.0f - posV.z;

			m_SpaceShip->translate(distV2);
			m_NextDestination -= distV;
			posV = m_SpaceShip->getPosition() - m_Camera->mPosW;
			m_gameSound->get3DBuffer()->SetPosition(posV.x,posV.y,posV.z,DS3D_IMMEDIATE);
			//posV = m_NextDestination * m_SpaceShip->m_Speed;
			//m_gameSound->get3DBuffer()->SetVelocity(posV.x,posV.y,posV.z,DS3D_IMMEDIATE);

		}
		if(!(m_SpaceShip->m_ZRotOrient < 3.0f && m_SpaceShip->m_ZRotOrient > -3.0f))
			m_SpaceShip->rotateZ( -m_SpaceShip->m_ZRotOrient / 50.0f);
		m_LastRun = timeGetTime();

	}
//	m_SpaceShip->rotateAbsoluteX( 0);

	return true;
}

bool GameControlListener::frameEnded			( float timeElapsed) 
{
	return true;
}
