#pragma once
#include "keyboardlistener.h"
#include "FrameListener.h"
#include "MouseListener.h"
#include "SpaceShip.h"
#include "Sound.h"
#include "Audio.h"
#include "Camera.h"
#include "ParticleSystem.h"
#include "GunLayout.h"
#include "ExplosionLayout.h"
class GameControlListener :
	virtual public KeyboardListener , virtual public MouseListener , virtual public FrameListener
{
public:
	GameControlListener					( SpaceShip *p_Renderable, Camera *p_Camera, ParticleGroupLayout *pgl );
	~GameControlListener					( void );
	virtual bool keyPressed				( Keyboard		*p_Keyboard, float timeElapsed) ;
	virtual bool keyReleased			( Keyboard		*p_Keyboard, float timeElapsed) ;

	virtual bool mouseButtonReleased	( MouseState	&p_MouseEvent, float timeElapsed) ;
	virtual bool mouseButtonPressed		( MouseState	&p_MouseEvent, float timeElapsed) ;
	virtual bool mouseMoved				( MouseState	&p_MouseEvent, float timeElapsed) ;

	virtual bool frameStarted			( float timeElapsed) ;
	virtual bool frameEnded				( float timeElapsed) ;

public:
	SpaceShip				*m_SpaceShip;
	Camera					*m_Camera;

	D3DXVECTOR3				m_NextDestination;
	Sound					*m_gameSound;
	DWORD					m_LastRun;
};
