#pragma once
#include "framelistener.h"
#include "SceneManager.h"
#include "PresentBox.h"
#include "SpaceShip.h"
#include "LandShark.h"

using namespace LandShark;

class GamePlayFrameListener :
	public FrameListener
{
public:
	GamePlayFrameListener( SceneManager *p_SceneManager, SpaceShip *p_SpaceShip, Keyboard *p_Keyboard, LandSharkGame *p_Game);
	~GamePlayFrameListener(void);
	
	bool frameStarted(float p_TimeElapsed);

	void				runPartOne(float p_TimeElapsed);
	void				runFinalPart(float p_TimeElapsed);
	
	SceneManager		*m_SceneMgr;

	float				m_Difficulty;
	DWORD				m_LastObjectCreateTime;
	DWORD				m_TotalTime;
	LPDIRECT3DDEVICE9	m_Device;
	SpaceShip			*m_SpaceShip;
	float				m_MaxDifficulty;
	Keyboard			*m_Keyboard;

	Sprite				*m_MenuArrow;

	LandSharkGame		*m_Game;
};
