#pragma once

#include <d3dx9.h>
#include <iostream>
#include "Sound.h"
#include "SpriteManager.h"

class GameStats
{
protected:
	GameStats(LPDIRECT3DDEVICE9 p_Device);
public:
	~GameStats();

	void onLostDevice();
	void onResetDevice();

	void addFrags		(int p_Frags = 1)	{	m_NumOfFrags += p_Frags; m_NeedRefresh = true;}
	void addPoints		(int p_Points)		
	{	
		m_DestinationScore += p_Points;
		if( m_DestinationScore < 0 )
			m_DestinationScore = 0;
		m_NeedRefresh = true;
	}
	void subPoints		(int p_Points)		
	{
		m_DestinationScore -= p_Points; 
		if( m_DestinationScore < 0 )
			m_DestinationScore = 0;
		m_NeedRefresh = true;
	}
	void display();

	void setBulletPower	(int p_BulletPower)	{	m_BulletPower	=	p_BulletPower; m_NeedRefresh = true;}
	void setHealth		(int p_Health)		{	m_Health		=	p_Health; m_NeedRefresh = true;}
	void setNOfBullets	(int p_NOfBullets)	{	m_NOfBullets	=	p_NOfBullets; m_NeedRefresh = true;}
	void setRange		(int p_Range)		{	m_Range			=	p_Range; m_NeedRefresh = true;}
	void setLives		(int p_live)		{	m_Lives			=	p_live; m_NeedRefresh = true;}

	static void create(LPDIRECT3DDEVICE9 p_Device);
	static GameStats* getSingleton();

	int		m_NumOfRenderObjects;
	bool		m_IsGameRunning;
	bool		m_IsMenuRunning;

private:
	// Prevent copying
	GameStats(const GameStats& rhs);
	GameStats& operator=(const GameStats& rhs);
	
private:
	ID3DXFont* m_Font;

	int			m_CurrentScore;
	int			m_DestinationScore;
	DWORD		m_LastRun;
	int			m_NumOfFrags;
	int			m_Range;
	int			m_BulletPower;
	int			m_NOfBullets;
	int			m_Health;

	Sound		*m_PointUpSound;
	Sound		*m_PointDownSound;

	bool		m_NeedRefresh;

	Sprite		*m_Numbers[7];
	Sprite		*m_GamePanel;

	int			m_Lives;


	LPDIRECT3DDEVICE9	m_Device;




};
