#include "IODevice.h"

LPDIRECTINPUT8 ms_pDIObject = NULL;

IODevice::IODevice(HWND	&p_HWin)
{
	m_HWin = p_HWin;
}//IODevice

IODevice::~IODevice(void)
{
	if(ms_pDIObject != NULL)
	 {
		 ms_pDIObject->Release();
		 ms_pDIObject = NULL;
	 }
}//~IODevice

bool IODevice::initDirectInput(void)
{
	if(!ms_pDIObject){
		if(FAILED(DirectInput8Create(GetModuleHandle(NULL),
									 DIRECTINPUT_VERSION,
									 IID_IDirectInput8,
									 (void**)&ms_pDIObject,
									 NULL)))
		{
			 return false;
		}
	}

	return true;
} //InitDirectInput

bool	IODevice::acquireInputDevice ( DWORD delayTime )
{

	DWORD deviceRecoverStartTime = timeGetTime() ;	//we need to attemp for a while because of harware latency		
	HRESULT hr = m_pDirectInputDevice->Acquire();
	
	// trying to get device back for delayTime milliseconds
	while ( FAILED( hr ) && ((timeGetTime() - deviceRecoverStartTime  < delayTime )) )	
	{
		hr = m_pDirectInputDevice->Acquire();
	}

	return SUCCEEDED(hr);
}//acquireInputDevice



LPDIRECTINPUT8	IODevice::getDirectInputObject()
{
	return ms_pDIObject;
}//getDirectInputObject
