#include "LandShark.h"
#include "GameControlListener.h"
#include "PhysicsEngine.h"
#include "PresentBox.h"
#include "SpriteManager.h"
#include "GameStats.h"
#include "GamePlayFrameListener.h"


using namespace LandShark;

LandSharkGame::LandSharkGame( HINSTANCE hinstance )
:GameBase( hinstance )
{
	initGame();
	createScene();
}

LandSharkGame::~LandSharkGame(void)
{

}



void LandSharkGame::initGame		( void ) 
{


	startMenu();
}


void LandSharkGame::createScene		( void ) 
{

}


void LandSharkGame::startMenu		( void ) 
{
	GameStats::getSingleton()->m_IsMenuRunning = true;
	GameStats::getSingleton()->m_IsGameRunning = false;
	SpriteManager::getSingleton()->registerSprites(m_Device,string("gamestart"),string("gamestart.png"),1024,768,1,1);
	Sprite *s = SpriteManager::getSingleton()->createSprite(string("gamestart"),INFINITE,0,D3DXSPRITE_ALPHABLEND,D3DXVECTOR3(0,0.0f,0));
	m_SceneMgr->m_Sprites.push_back(s);


	m_SceneMgr->m_Camera->mPosW = Vector3(0,200.0f,-150.0f);

	m_SceneMgr->m_Camera->lookAt(m_SceneMgr->m_Camera->mPosW,D3DXVECTOR3(0,0,0.0f),D3DXVECTOR3(0,1.0,0));

	m_SpaceShip = new SpaceShip();
	m_SpaceShip->LoadFromXFile("LandShark.x",m_Device);

	m_SpaceShip->scale(Vector3(.03f,.03f,.03f));
	m_SpaceShip->teleport(Vector3(0,0,-50.0f));

	SpriteManager::getSingleton()->registerSprites(m_Device,string("electricalsparks16_alpha"),string("electricalsparks16_alpha.jpg"),1024,1024,4,4);
	SpriteManager::getSingleton()->registerSprites(m_Device,string("explosion716"),string("explosion716.jpg"),1024,1024,4,4);
	m_SceneMgr->addListener(new GamePlayFrameListener(m_SceneMgr,m_SpaceShip,m_Keyboard,this ));
}

void LandSharkGame::startGame		( void ) 
{
	m_SceneMgr->m_Sprites.pop_back();
	m_SceneMgr->addRenderableObject(m_SpaceShip);
	PhysicsEngine::getSingleton()->registerPhyObject(m_SpaceShip);

	ParticleGroupLayout *pgl = new ParticleGroupLayout( 128 );

	m_SceneMgr->addListener( (new GameControlListener(m_SpaceShip,m_SceneMgr->m_Camera, pgl)) );
	GameStats::getSingleton()->m_IsGameRunning = true;
	GameStats::getSingleton()->m_IsMenuRunning= false;





	float f = 100.0f;
	long l = Audio::getSingleton()->getVolume();
//	Audio::getSingleton()->setVolume(  l * 2L + 100L);


	Sound::getSound("Trumpet1")->play();

}
