#pragma once
#include "IODevice.h"
class IODevice;
//constants for mouse buttons 
typedef enum __MouseButton{
	MOUSE_Left		=	0x01,
	MOUSE_Right		=	0x01 << 1,
	MOUSE_Middle	=	0x01 << 2,
	MOUSE_4BUTTON	=	0x01 << 3,
	MOUSE_5BUTTON	=	0x01 << 4,
	MOUSE_6BUTTON	=	0x01 << 5,
	MOUSE_7BUTTON	=	0x01 << 6,
	MOUSE_8BUTTON	=	0x01 << 7,

} MouseButton;


typedef struct __MouseState
{
	long x;
	long y;
	long z;
	BYTE buttons;
} MouseState;



class Mouse :
	public IODevice
{
public:
	Mouse(HWND	&p_HWin);
	~Mouse(void);
	bool				update(void);
	bool				initMouse(void);       //init mouse 

	bool				isButtonDown(MouseButton p_Button);		// is the key down
	bool				isButtonReleased(MouseButton p_Button);	// is the key released
	bool				isAnyButtonDown();						// is any button down
	bool				isAnyButtonReleased();					// is any button released
	bool				isMouseMoved();							// is mouse moved
	bool				isAnythingHappened();					// is any key down or released or is the mouse moved

    LPDIRECTINPUTDEVICE8 m_pDIMouseDevice;				//mouse device 
	MouseState			m_MouseButtonDownState;			//current mouse state after update
	MouseState			m_MouseButtonReleaseState;		//current mouse release state after update
	MouseState			m_LastButtonDownState;			//previous mouse state after update

	DIDEVCAPS			m_MouseCapabilities;			//device capabilities

};
