#pragma once
#include <d3dx9.h>
#include "Tools.h"
#include "PhysicsObject.h"

typedef struct __ParticleVertex
{
    D3DXVECTOR3 m_Position;
    D3DCOLOR    m_Color;

	enum FVF
	{
		FVF_Flags = D3DFVF_XYZ | D3DFVF_DIFFUSE
	};
}ParticleVertex;



class Particle : public PhysicsParticle
{
public:
	Particle(CollisionGroup p_CollGroup):PhysicsParticle(p_CollGroup){};
	~Particle(){};
    D3DXVECTOR3			m_Position;		// Position of particle
    D3DXVECTOR3			m_Velocity;		// Velocity of particle
	bool				m_IsAlive;
	D3DXCOLOR			m_Color;
	D3DXVECTOR3			getPosition(){return m_Position;}

	void	processCollision(PhysicsObject *p_PhyObject)
	{
		m_IsAlive = false;
	};
//	ParticleGoupAttributes	*m_attributtes;	// Attributes of particle
};