#include "ParticleGroupLayout.h"



ParticleGroupLayout::ParticleGroupLayout( unsigned int p_NumOfParticles, float p_LifeLength, 
									float p_SizeOfParticle, D3DXCOLOR& p_Color, string& p_TextureName )
{
	m_NumOfParticles	=	p_NumOfParticles;
	m_SizeOfParticle	=	p_SizeOfParticle;
	m_Color				=	p_Color;
	m_LifeLength		=	p_LifeLength;
	m_TextureName		=	p_TextureName;
	m_CollisionGroup	=	COLLISION_GROUP_NONE;
	m_CreateRectengle	=	true;
}
ParticleGroupLayout::~ParticleGroupLayout()
{
}


void ParticleGroupLayout::initParticles		(Particle ***particles)
{

	for( int i = 0 ; i < m_NumOfParticles ; i++ )
	{
		(*particles)[i]->m_IsAlive = true;
	}
}



void ParticleGroupLayout::updateParticles	(Particle ***particles)
{


#ifdef	DEBUG_LEVEL_1
	if((*particles) == NULL)
	{
		Tools::LOG("ParticleGroupLayout::updateParticles @ (*particles) == NULL ");
		return;
	}
#endif


	m_Rectangle.left = m_Rectangle.right = (*particles)[0]->m_Position.x;
	m_Rectangle.bottom = m_Rectangle.top = (*particles)[0]->m_Position.z;

	for( int i = 1 ; i < m_NumOfParticles ; i++ )
	{	
		D3DXVECTOR3& posTmp = (*particles)[i]->m_Position;
		
		if(posTmp.x > m_Rectangle.right)
			m_Rectangle.right = posTmp.x;
		else if (posTmp.x < m_Rectangle.left)
			m_Rectangle.left = posTmp.x;
		if(posTmp.z > m_Rectangle.top)
			m_Rectangle.top = posTmp.z;
		else if (posTmp.z < m_Rectangle.bottom)
			m_Rectangle.bottom = posTmp.z;
	}

	//remember the size of the particle
	m_Rectangle.bottom -= 1.0f;
	m_Rectangle.top	+= 1.0f;
	m_Rectangle.left -= 1.0f;
	m_Rectangle.right -= 1.0f;
}


