#pragma once
#include "Particle.h"
#include "PhysicsObject.h"


/*
* This is tha main layout class
* Particles groups can be created only with
* a certain behaviour which is being represented in
* this layout 
*/
class ParticleGroupLayout
{
public:
	
	ParticleGroupLayout( unsigned int p_NumOfParticles, float p_Life = 500.0f, 
							float p_SizeOfParticle = 1.0f , D3DXCOLOR& p_Color = D3DXCOLOR(1.0f,1.0f,1.0f,1.0f) ,
									  string& p_TextureName = string("particle.bmp") );
	~ParticleGroupLayout();


	virtual void		initParticles		(Particle ***particles);

	virtual void		updateParticles		(Particle ***particles);


	string				m_TextureName;
	float				m_LifeLength;
	float				m_SizeOfParticle;
	D3DXCOLOR			m_Color;
	unsigned int		m_NumOfParticles;
	CollisionGroup		m_CollisionGroup;
	bool				m_CreateRectengle;	// if the bounding box will be calculated for the group
	

	RECTF				m_Rectangle;

};