#pragma once
#include <vector>
#include <map>
#include <string>
#include "ParticleGroup.h"
#include "PhysicsEngine.h"

//using std::map;
//using std::vector;
// using std::string;

using namespace std;







class ParticleSystem
{
private:
	ParticleSystem( LPDIRECT3DDEVICE9 p_D3dDevice );	// singleton pattern
public:
	~ParticleSystem(void);

	void				initTextures		(  );
	HRESULT				addTexture			( string p_FileName );
	void				removeParticleGroup	( vector<ParticleGroup*>::iterator& p_pIter );
	void				createParticles		( ParticleGroupLayout* p_Layout );			
	void				render				(  );
	LPDIRECT3DTEXTURE9	getTexture			( string p_textureName ){ return textureMap[p_textureName]; };
	void				update				( float p_ElapsedTime );

	void				giveParticles		( unsigned int p_NumOfParticles, Particle*** p_dpParticleArray);
	void				removeParticles		( unsigned int p_NumOfParticles, Particle*** p_dpParticleArray);

	static	ParticleSystem* getSingleton();
	static	void			create( LPDIRECT3DDEVICE9 pd3dDevice );


	map <string, LPDIRECT3DTEXTURE9>	textureMap;
	vector	<ParticleGroup*>			m_AliveParticleGroupsPool;
	vector	<ParticleGroup*>			m_DeadParticleGroupsPool;

	vector	<Particle*>					m_DeadParticlesPool;




protected:
	LPDIRECT3DDEVICE9			m_Device;
    LPDIRECT3DVERTEXBUFFER9		m_VertexBuffer;          // Vertex buffer for point sprites

    DWORD						m_VBOffset;					// Gives the offset of the vertex buffer chunk that's currently being filled
    static const DWORD			m_Flush		=	512;		// Number of point sprites to load before sending them to hardware(512 = 2048 divided into 4 chunks)
    static const DWORD			m_Discard	=	4096;		// Max number of point sprites the vertex buffer can load until we are forced to discard and start over
	
	DWORD						m_PreviousRenderTime;

};




