#pragma once
#include <vector>
#include <list>
#include "PhysicsObject.h"
#include "ParticleGroup.h"

using std::vector;
using std::list;

class PhysicsEngine
{
protected:
	PhysicsEngine(void);
public:
	~PhysicsEngine(void);
	
	void							registerPhyObject(PhysicsObject *p_PhyObj);
	void							unRegisterPhyObject(PhysicsObject *p_PhyObj);


	vector<PhysicsObject*>			m_PhysicsRegistery;

	void detectParticleGroupVSSphere(ParticleGroup *p_Particle1,PhysicsSphere *p_Particle2);
	void detectSphereVSSphere(PhysicsSphere *p_Particle1,PhysicsSphere *p_Particle2);
	void detectCollisions();
	void cleanUp();
	
	static PhysicsEngine*		getSingleton();
private:
	void deleteFromVector( PhysicsObject *p_PhyObj);
	void removeDeadObjects( list<vector<PhysicsObject*>::iterator> &deadList);


};
