#include "PhysicsFrameListener.h"
#include "Stats.h"
PhysicsFrameListener::PhysicsFrameListener(void)
{
	m_ProcessTimeLength = 0;
	m_PhyEngine = PhysicsEngine::getSingleton();
	m_Priority = 2;
}

PhysicsFrameListener::~PhysicsFrameListener(void)
{
}

/*
*	this frame listener runs the physics world and 
*	checks for the time used. if necessary, decreases the
*	priority to consume less time
*
*/
bool PhysicsFrameListener::frameStarted( float timeElapsed)	
{
	DWORD startTime = timeGetTime();

	try
	{
		m_PhyEngine->detectCollisions();
	}
	catch(...)
	{
		Tools::LOG("exception @ PhysicsFrameListener::frameStarted");
	}

	m_ProcessTimeLength = timeGetTime() - startTime;

	if(m_ProcessTimeLength < 2 )
	{
		m_Priority = 2;
	}
	else if(m_ProcessTimeLength < 4 )
	{
		m_Priority = 3;
	}
	else if( m_ProcessTimeLength < 8 )
	{
		m_Priority = 4;
	}
	else if( m_ProcessTimeLength < 16 )
	{
		m_Priority = 5;
	}
	else if( m_ProcessTimeLength < 32 )
	{
		m_Priority = 6;
	}
	else if( m_ProcessTimeLength < 64 )
	{
		m_Priority = 7;
	}
	else if(m_ProcessTimeLength > 100)
	{
		if(m_Priority < 9)
			m_Priority++;
	}

	Stats::getSingleton()->updatePhyTime(m_ProcessTimeLength);
	return true;

}

bool PhysicsFrameListener::frameEnded( float timeElapsed)		
{
	return true;
}