#pragma once
#include "Tools.h"
#include <d3dx9.h>

typedef BYTE CollisionGroup;

#define		COLLISION_GROUP_NONE	(CollisionGroup)0
#define		COLLISION_GROUP_A		(CollisionGroup)(1)
#define		COLLISION_GROUP_B		(CollisionGroup)(1 << 1)
#define		COLLISION_GROUP_C		(CollisionGroup)(1 << 2)
#define		COLLISION_GROUP_D		(CollisionGroup)(1 << 3)
#define		COLLISION_GROUP_E		(CollisionGroup)(1 << 5)
#define		COLLISION_GROUP_G		(CollisionGroup)(1 << 6)
#define		COLLISION_GROUP_H		(CollisionGroup)(1 << 7)
#define		COLLISION_GROUP_ALL		(CollisionGroup)(255)


class PhysicsObject
{
public:
	enum PhysicsObjectType
	{
		UNDEFINED = 0,
		PARTICLE = 1,
		PARTICLE_GROUP ,
		CUBE ,
		SPHERE
	};


public:
	PhysicsObject(CollisionGroup p_CollGroup);
	~PhysicsObject(void);


	virtual PhysicsObjectType		getPhysicsObjectType() = 0;
//	virtual CollisionGroup			getCollisionGroup() = 0;

	virtual	void			processCollision(PhysicsObject *p_PhyObject) {};


	CollisionGroup			m_CollisionGroup;
	bool					m_IsDead;
	bool					m_IsUnregistered;

};


class PhysicsParticle: public PhysicsObject
{
public:
	PhysicsParticle(CollisionGroup p_CollGroup);
	~PhysicsParticle(void){};
	
	virtual D3DXVECTOR3		getPosition() = 0;
	//float				getSize() = 0;
	PhysicsObjectType		getPhysicsObjectType() {return PARTICLE;};


};


class PhysicsSphere: public PhysicsObject
{
public:
	PhysicsSphere(CollisionGroup p_CollGroup);
	~PhysicsSphere(void){};
	
	virtual D3DXVECTOR3			getCenter() = 0;
	virtual float				getRadius() = 0;
	PhysicsObjectType		getPhysicsObjectType() {return SPHERE;};


};