#pragma once
#include "RenderableObject.h"
#include "PhysicsObject.h"
#include "ParticleSystem.h"
#include "ExplosionLayout.h"
#include "SpriteManager.h"
#include "PrimaryGunLayout.h"
#include "SecondGunLayout.h"
#include "Sound.h"


class PresentBox : public RenderableObject, public PhysicsSphere
{
public:
	PresentBox(CollisionGroup p_CollGroup);
	~PresentBox(void);

	void				render(LPDIRECT3DDEVICE9 p_Device);

	D3DXVECTOR3			getCenter() ;
	float				getRadius() ;


	Sprite				*m_Sprite;	
	float				m_Health;

	D3DXVECTOR3			m_Speed;
	


private:
	unsigned long int	m_RenderCount;
	DWORD				m_LastRenderTime;
	bool				m_FirstSpriteRun;


};

class ExplosionBox : public PresentBox
{
protected:
	ExplosionBox();
public:
	virtual void		processCollision(PhysicsObject *p_PhyObject);

	static	ExplosionBox*	createExplosionBox(LPDIRECT3DDEVICE9 p_Device , D3DXVECTOR3 &p_Pos);

};



class PowerBox : public PresentBox
{
protected:
	PowerBox();
public:
	virtual void		processCollision(PhysicsObject *p_PhyObject);

	static	PowerBox*	createPowerBox(LPDIRECT3DDEVICE9 p_Device , D3DXVECTOR3 &p_Pos);

};

class SpeedBox : public PresentBox
{
protected:
	SpeedBox();
public:
	virtual void		processCollision(PhysicsObject *p_PhyObject);

	static	SpeedBox*	createSpeedBox(LPDIRECT3DDEVICE9 p_Device , D3DXVECTOR3 &p_Pos);

};



class MultiBox : public PresentBox
{
protected:
	MultiBox();
public:
	virtual void		processCollision(PhysicsObject *p_PhyObject);

	static	MultiBox*	createMultiBox(LPDIRECT3DDEVICE9 p_Device , D3DXVECTOR3 &p_Pos);

};





class SecondGunBox : public PresentBox
{
protected:
	SecondGunBox();
public:
	virtual void		processCollision(PhysicsObject *p_PhyObject);

	static	SecondGunBox*	createSecondGunBox(LPDIRECT3DDEVICE9 p_Device , D3DXVECTOR3 &p_Pos);

};
