#include "PrimaryGunLayout.h"

PrimaryGunLayout::PrimaryGunLayout(unsigned int p_NumOfParticles,
									D3DXMATRIX* wM, float p_LifeLength, 
									float p_SizeOfParticle, D3DXCOLOR& p_Color, string& p_TextureName)
:GunLayout(p_NumOfParticles,wM,p_LifeLength,p_SizeOfParticle,p_Color,p_TextureName)
{
	m_CreateRectengle = false;

}

PrimaryGunLayout::~PrimaryGunLayout(void)
{
}

void PrimaryGunLayout::initParticles		(Particle ***particles)
{

	ParticleGroupLayout::initParticles(particles);

	float angle ;
	int i = 0;
	Particle *particle;

	if(m_NumOfParticles%2 == 1)
	{
		particle = (*particles)[i];
		particle->m_Position.x = wM->_41;
		particle->m_Position.y = wM->_42;
		particle->m_Position.z = wM->_43-5.0f;
		particle->m_Velocity.x = 0;
		particle->m_Velocity.y = 0;
		particle->m_Velocity.z = 4.5f;
		particle->m_IsAlive = true;
		particle->m_Color = m_Color;
		i++;
	}
	for(/* i = 0*/; i < m_NumOfParticles ; i++ )
	{
		particle = (*particles)[i];

		angle = GRAD2DEGREE(  (60.0f + ((float)i * 60.0f / (float)(m_NumOfParticles))) );
		(*particles)[i]->m_Position.x = wM->_41 ;
		(*particles)[i]->m_Position.y = wM->_42;
		(*particles)[i]->m_Position.z = wM->_43;

		particle->m_Velocity.x = m_SpreadFactor * (cosf(angle) );
		particle->m_Velocity.y =4.50f * wM->_21 * (float)i;
		particle->m_Velocity.z =4.50f * (sinf(angle))  ;
		particle->m_IsAlive = true;
		particle->m_Color = m_Color;

		//(*particles)[i]->m_Velocity = t;//D3DXVECTOR3(15.0f * cosf(angle),15.0f * wM->_21 ,15.0f * sinf(angle));
	}
}



void PrimaryGunLayout::updateParticles	(Particle ***particles)
{
#ifdef	DEBUG_LEVEL_1
	if(particles == NULL || (*particles) == NULL)
	{
		Tools::LOG("PrimaryGunLayout::updateParticles @ (*particles) or (particles) == NULL ");
		return;
	}
#endif

	for( int i = 0 ; i < m_NumOfParticles ; i++ )
	{		
		(*particles)[i]->m_Position += (*particles)[i]->m_Velocity ;
		(*particles)[i]->m_Color /= 1.1f;
	}
	if(m_CreateRectengle)
		ParticleGroupLayout::updateParticles(particles);


}
