/*
////////////////////////////////////////////////
// UMUT RIZA ERTURK / umutert@gmail.com       //
// 0703851                                    //
// university of abertay dundee               //
// 14-12-2007                                 //
// intel core duo t7100                       //
// nvidia 8400m gt                            //
// Windows Vista                              //
// M. Visual Studio 2005 v.8.05               //
// directX 9.0c                               //
////////////////////////////////////////////////
*/

#include "Renderable.h"
#include "Tools.h"

Renderable::Renderable(std::string &p_Name)
{
	if (p_Name == "")
	{
		char tmpName[12];
		ZeroMemory( tmpName, sizeof(char) * 12 );
		unsigned int tmp = (unsigned int)GetTickCount() ^ ((unsigned int)this);
		itoa(tmp,tmpName,16);
		p_Name = p_Name + tmpName;
	}

	m_Name = p_Name;

	m_CurrentState = RENDERABLE_NOT_LOADED;
}

void Renderable::translate(D3DXVECTOR3 &trans)
{
	D3DXMATRIX tmp;

	D3DXMatrixTranslation(&tmp,trans.x,trans.y,trans.z);
	worldM *= tmp; 
}

void Renderable::teleport(D3DXVECTOR3 &tele)
{	
	worldM._41 = tele.x;; 
	worldM._42 = tele.y;; 
	worldM._43 = tele.z;; 
}


void Renderable::rotateX(float angle)
{
	D3DXMATRIX tmp;
	D3DXVECTOR3 t = getPosition();
	
		translate(-t);
			D3DXMatrixRotationX(&tmp, GRAD2DEGREE(angle));
			worldM *= tmp; 
		translate(t);
}
void Renderable::moveForward(float dist){
	translate(D3DXVECTOR3(-dist*sinf(GRAD2DEGREE(dirA)),0,-dist*cosf(GRAD2DEGREE(dirA))));
	
}
void Renderable::rotateY(float angle)
{
	dirA += angle;
	D3DXMATRIX tmp;
	D3DXVECTOR3 t = getPosition();
	
	
		translate(-t);
			D3DXMatrixRotationY(&tmp,GRAD2DEGREE(angle) );
			worldM *= tmp; 
		translate(t);
}

void Renderable::rotateZ(float angle)
{
	D3DXMATRIX tmp;
	D3DXVECTOR3 t = getPosition();
	
		translate(-t);
			D3DXMatrixRotationZ(&tmp,GRAD2DEGREE(angle));
			worldM *= tmp; 
		translate(t);
}


void Renderable::scale(D3DXVECTOR3 &scl)
{
	D3DXMATRIX tmp;
	D3DXVECTOR3 t = getPosition();
	
	translate(-t);
		D3DXMatrixScaling(&tmp,scl.x,scl.y,scl.z);
		m_BoundingSphereRadius *= (scl.x + scl.y + scl.z) / 3.0f;
		worldM *= tmp; 
	translate(t);

}


D3DXVECTOR3 Renderable::getPosition()
{
	return D3DXVECTOR3(worldM._41,worldM._42,worldM._43);
}

