#pragma once
#include <d3dx9.h>
#include <string>

using namespace std;

enum OBJTYPE
			{
				UNDEFINED,
				Static,
				Moveable,
				Ground,
				SkyBox,
				Animation,
				SPACE_SHIP,
				PRESENT_BOX,
				ASTEROID,
				ENEMY_SHIP
			};
enum RenderableState
{
	RENDERABLE_DEAD = -2,
	RENDERABLE_NOT_LOADED = -1,
	RENDERABLE_LOADED = 1,
	RENDERABLE_RUNNING = 2
};

class Renderable
{
public:

	Renderable(std::string &p_Name);


public:
	
	virtual	void render(LPDIRECT3DDEVICE9 device) {};
	virtual	void render(LPDIRECT3DDEVICE9 device,D3DXMATRIX &wM) {};
	virtual	void renderShadow(LPDIRECT3DDEVICE9 device,D3DXMATRIX &shadowM) {};


public:

	virtual void translate(D3DXVECTOR3 &trans);
	virtual void teleport(D3DXVECTOR3 &tele);		
	virtual void rotateX(float angle);
	virtual void rotateY(float angle);
	virtual void rotateZ(float angle);
	virtual void scale(D3DXVECTOR3 &scl);
	virtual void moveForward(float dist);
	D3DXVECTOR3 getPosition();


public:
	D3DXMATRIX			worldM;
	float				dirA;
	OBJTYPE				type;
	string				m_Name;
	float				m_BoundingSphereRadius;
	RenderableState		m_CurrentState;

};
