#pragma once
#include "Renderable.h"


class RenderableObject: public Renderable
{
public:
	RenderableObject(OBJTYPE t = UNDEFINED, string &p_Name = string(""));
	RenderableObject(string &p_Name);
	~RenderableObject(void);

public:
		virtual void render(LPDIRECT3DDEVICE9 device);
		virtual void render(LPDIRECT3DDEVICE9 device,D3DXMATRIX &wM);
		virtual void renderShadow(LPDIRECT3DDEVICE9 device,D3DXMATRIX &shadowM);
		virtual bool LoadFromXFile	(
								LPCSTR filename, 
								LPDIRECT3DDEVICE9 device,
								DWORD Options = D3DXMESH_SYSTEMMEM, 
								LPD3DXBUFFER *ppAdjacency = NULL,
								LPD3DXBUFFER *ppEffectInstances = NULL 
							);

		bool LoadXFromMemory(
								LPCVOID p_Memory, 
								DWORD p_SizeOfMem ,
								LPDIRECT3DDEVICE9 device,																
								DWORD Options, 
								LPD3DXBUFFER *ppAdjacency,
								LPD3DXBUFFER *ppEffectInstances
							);


public:

	LPD3DXMESH					*m_Mesh;
	D3DMATERIAL9				*m_MeshMaterials;
	LPDIRECT3DTEXTURE9			*m_MeshTextures;

	DWORD						m_NumMaterials;



	
};

