#include "SecondGunLayout.h"

SecondGunLayout::SecondGunLayout(unsigned int p_NumOfParticles,
									D3DXMATRIX* wM, float p_LifeLength, 
									float p_SizeOfParticle, D3DXCOLOR& p_Color, string& p_TextureName)
:GunLayout(p_NumOfParticles,wM,p_LifeLength,p_SizeOfParticle,p_Color,p_TextureName)
{
	this->wM = wM;
	m_BulletPower = 1000.0f;
	m_CreateRectengle = false;
}

SecondGunLayout::~SecondGunLayout(void)
{
}
void SecondGunLayout::initParticles		(Particle ***particles)
{
#ifdef	DEBUG_LEVEL_1
	if(particles == NULL || (*particles) == NULL)
	{
		Tools::LOG("SecondGunLayout::initParticles @ (*particles) or (particles) == NULL ");
		return;
	}
#endif


	float angle ;
	int i = 0;
	Particle *particle;
	for( ; i < m_NumOfParticles ; i++ )
	{
		particle = (*particles)[i];

		particle->m_Position = D3DXVECTOR3(wM->_41 + Tools::rnd(-25.0f,25.0f), wM->_42 , wM->_43 + 5.0f );

		particle->m_Velocity.x = Tools::rnd(-1.5f,1.5f);
		particle->m_Velocity.y =0;
		particle->m_Velocity.z =1.0f;
		particle->m_IsAlive = true;
		particle->m_Color = m_Color;

		//(*particles)[i]->m_Velocity = t;//D3DXVECTOR3(15.0f * cosf(angle),15.0f * wM->_21 ,15.0f * sinf(angle));
	}
	if(m_CreateRectengle)
		ParticleGroupLayout::updateParticles(particles);
}



void SecondGunLayout::updateParticles	(Particle ***particles)
{
#ifdef	DEBUG_LEVEL_1
	if(particles == NULL || (*particles) == NULL)
	{
		Tools::LOG("PrimaryGunLayout::updateParticles @ (*particles) or (particles) == NULL ");
		return;
	}
#endif

	for( int i = 0 ; i < m_NumOfParticles ; i++ )
	{	
		(*particles)[i]->m_Position += (*particles)[i]->m_Velocity ;
	}
	if(m_CreateRectengle)
		ParticleGroupLayout::updateParticles(particles);

}
