#pragma once
#include"Audio.h"
#include <string>
#include <map>
using std::map;
using std::string;
using namespace std;

#define AUDIO_PATH_LIMIT			64

struct SAudioPathRef
{
	IDirectMusicAudioPath8*			pAudioPath;
	IDirectSound3DBuffer8*			p3DBuffer;
	short							sRefCounter;

	SAudioPathRef()		{ pAudioPath = NULL;p3DBuffer = NULL;sRefCounter = 0; }
};

class Sound
{
protected:
									Sound(char*,IDirectMusicAudioPath8*);

public:
	~Sound();

	void							play();
	void							stop();

	void							activateAudioPath(bool p_isActive);
	void							setVolume(long lVolume,DWORD dwDuration);
	void							setRepeats(DWORD p_Times);
	bool							isPlaying();

	inline IDirectMusicAudioPath8*	getAudioPath()		{ return m_AudioPath; }
	inline IDirectSound3DBuffer8*	get3DBuffer()		{ return m_3DBuffer; }

	static Sound*					registerSound(char *p_Name, char *p_FileName);
	static Sound*					registerSound(string &p_Name, string &p_FileName);
	static void						unregisterSound(string &p_Name);
	static Sound*					getSound(string &p_Name, bool p_NewInstance = false, string &p_FileName = string(""));
	static Sound*					getSound(char *p_Name);
	static void						scanDirectory(string p_Dir);
private:
	static SAudioPathRef			m_AudioPathRef[AUDIO_PATH_LIMIT];

	IDirectMusicPerformance8*		m_Performance;
	IDirectMusicLoader8*			m_Loader;
	IDirectMusicSegment8*			m_Segment;
	IDirectMusicAudioPath8*			m_AudioPath;
	IDirectSound3DBuffer8*			m_3DBuffer;
};

