#pragma once
#include "RenderableObject.h"
#include "PhysicsObject.h"
#include "SpaceShipGun.h"

class SpaceShip :
	public RenderableObject, public PhysicsSphere
{
public:
	SpaceShip(void);
	~SpaceShip(void);
	void				render(LPDIRECT3DDEVICE9 p_Device);
	void				reset();
	void				turningBackToGame();

	D3DXVECTOR3			getCenter() ;
	float				getRadius() ;

	void				rotateX(float p_Degree);
	void				rotateZ(float p_Degree);

	void				rotateAbsoluteX(float p_Degree);
	void				rotateAbsoluteZ(float p_Degree);

	void				processCollision(PhysicsObject *p_PhyObject);


	float				m_XRotOrient;
	float				m_YRotOrient;
	float				m_ZRotOrient;

	int					m_Health;
	float				m_Speed;
	int					m_Lives;

	DWORD				m_ResetTime;

	SpaceShipGun		*m_Gun[3];

	bool				m_IsTurnedBack;

};
