#include "SpaceShipGun.h"

SpaceShipGun::SpaceShipGun(D3DXMATRIX *p_WorldM, GunLayout *p_GunLayout, Sound *p_GunSound, float p_Speed)
{
	m_GunSound = p_GunSound;
	m_GunSound->get3DBuffer()->SetMinDistance(100.0f,DS3D_IMMEDIATE);
	m_GunSound->get3DBuffer()->SetMaxDistance(410.0f,DS3D_IMMEDIATE);

	m_InitialSpeed = m_GunSpeed = p_Speed;
	m_InitialGunLayout = m_GunLayout = p_GunLayout;
	this->m_GunLayout->m_CollisionGroup = COLLISION_GROUP_B | COLLISION_GROUP_D;
	m_LastAttackTime = 0;
}

SpaceShipGun::~SpaceShipGun(void)
{
}

void SpaceShipGun::reset()
{
	m_GunSpeed = m_InitialSpeed;	
	m_GunLayout = m_InitialGunLayout;
}

void SpaceShipGun::fire(D3DXVECTOR3 &p_Position, D3DXVECTOR3 &p_Speed)
{
	if( isReadyToFire() )
	{
		m_GunSound->get3DBuffer()->SetPosition(	p_Position.x,
												p_Position.y,
												p_Position.z,
												DS3D_IMMEDIATE);

		m_GunSound->get3DBuffer()->SetPosition(p_Position.x,p_Position.y,p_Position.z,DS3D_IMMEDIATE);
		m_GunSound->get3DBuffer()->SetVelocity(p_Speed.x,p_Speed.y,p_Speed.z,DS3D_IMMEDIATE);



		ParticleSystem::getSingleton()->createParticles(m_GunLayout);
			
		m_GunSound->play();
		m_LastAttackTime = timeGetTime();
	}
}


