#pragma once
#include "PrimaryGunLayout.h"
#include "SecondGunLayout.h"
#include "Sound.h"
#include "ParticleSystem.h"

class SpaceShipGun
{
public:
	SpaceShipGun(D3DXMATRIX *p_WorldM, GunLayout *p_GunLayout, Sound *p_GunSound, float p_Speed);
	~SpaceShipGun(void);
	
	void			fire(D3DXVECTOR3 &p_Position, D3DXVECTOR3 &p_Speed);
	void			reset();
	bool			isReadyToFire()
	{	
		return (((float)(timeGetTime() - m_LastAttackTime)) > (1000.0f / m_GunSpeed));
	}

	GunLayout		*m_GunLayout;
	GunLayout		*m_InitialGunLayout;


	float			m_GunSpeed;
	float			m_InitialSpeed;

	Sound			*m_GunSound;

	DWORD			m_LastAttackTime;
	
	
};
