#pragma once
#include "Tools.h"
#include <string>

using std::string;

#define D3DFVF_SPRITE_VERTEX ( D3DFVF_XYZ | D3DFVF_TEX1 )

struct SpriteVertex
{
    float x, y, z;
    float tu, tv;
};

const SpriteVertex g_quadVertices[] =
{
	{-1.0f, 1.0f, 0.0f,  0.0f,0.0f },
	{ 1.0f, 1.0f, 0.0f,  1.0f,0.0f },
	{-1.0f,-1.0f, 0.0f,  0.0f,1.0f },
	{ 1.0f,-1.0f, 0.0f,  1.0f,1.0f }
};


class SpriteLayout
{
public:
	SpriteLayout(string &p_TextureName, int p_TextureWidth, int p_TextureHeight, int p_NOfHorizontalFrames, int p_NOfVerticalFrames );
	~SpriteLayout();

	void					init(LPDIRECT3DDEVICE9	p_Device);
	void					loadTexture( LPDIRECT3DDEVICE9	p_Device );

	LPDIRECT3DTEXTURE9		m_SpriteTexture;
	LPD3DXSPRITE			m_Sprite ;
	
	string					m_TextureName;
	int						m_TextureWidth;
	int						m_TextureHeight;
	int						m_NOfHorizontalFrames;
	int						m_NOfVerticalFrames;

	int						m_NOfFrames;
	int						m_FrameWidth;
	int						m_FrameHeight;

	

};


class Sprite
{
public:
	Sprite(SpriteLayout *p_SpriteLayout,float p_TimeBtwFrames, int p_NumOfLoops, DWORD p_RenderFlag , D3DXVECTOR3& p_RectOffset );
	~Sprite(void);
	
	void			render(LPDIRECT3DDEVICE9	p_Device);
	void			nextFrame(int p_NumOfFrame = 1);
	void			prevFrame(int p_NumOfFrame = 1);

	SpriteLayout	*m_SpriteLayout;
	int				m_CurrentFrame;
	float			m_TimeBtwFrames;
	int				m_NumOfLoops;
	int				m_CurrentLoop;

	RECT			m_SrcRect;

	bool			m_Dead;

	DWORD			m_RenderFlag;
	D3DXVECTOR3		m_RectOffset;
	void			refreshRectangle();

private:
	DWORD			m_LastTime;



};
