#include "SpriteManager.h"
Sprite *g_SpriteNotFound = NULL;

SpriteManager::SpriteManager(void)
{
}

SpriteManager::~SpriteManager(void)
{
}

Sprite*	SpriteManager::createSprite( string &p_StripeName, float p_TimeBtwFrames, int p_NumOfLoops, DWORD p_RenderFlag , D3DXVECTOR3& p_RectOffset)
{
	SpriteLayout *sL = m_SpriteLayouts[p_StripeName];
	
	if(sL == NULL)
	{
		Tools::LOG("SpriteManager::createSprite @ Cannot find '"+p_StripeName+"'");
		if(g_SpriteNotFound == NULL)
			g_SpriteNotFound = new Sprite(m_SpriteLayouts["not-found"], p_TimeBtwFrames, p_NumOfLoops,p_RenderFlag, p_RectOffset);

		return g_SpriteNotFound;
	}
	else
	{
		return ( new Sprite(sL, p_TimeBtwFrames, p_NumOfLoops,p_RenderFlag, p_RectOffset) );
	}

}

void SpriteManager::registerSprites(LPDIRECT3DDEVICE9	p_Device, string &p_StripeName, string &p_TextureName, int p_TextureWidth, int p_TextureHeight, int p_NOfHorizontalFrames, int p_NOfVerticalFrames )
{
	if(m_SpriteLayouts[p_StripeName] != NULL)
	{
		Tools::LOG("SpriteManager::registerSprites @ " + p_StripeName + " is already registered ("+p_TextureName+")");
		return;
	}
	
	SpriteLayout *sL = new SpriteLayout(p_TextureName, p_TextureWidth, p_TextureHeight, p_NOfHorizontalFrames, p_NOfVerticalFrames );

	sL->init(p_Device);

	m_SpriteLayouts[p_StripeName] = sL;

	Tools::LOG("SpriteManager::registerSprites @ " + p_StripeName + " is registered ("+p_TextureName+")");

}


SpriteManager* g_SpriteManagerInstance = NULL;

SpriteManager*	SpriteManager::getSingleton()
{
	if(!g_SpriteManagerInstance)
		g_SpriteManagerInstance = new SpriteManager();

	return g_SpriteManagerInstance;
}
