#pragma once
#include "Sprite.h"
#include <map>
#include <string>
/*
*	this class is the manager class for sprites
*	sprites need to be registered first before being created.
*/
using std::string;
using std::map;

class SpriteManager
{
protected:
	SpriteManager(void);
public:
	~SpriteManager(void);

	Sprite*						createSprite	( 
												string &p_StripeName , 
												float p_TimeBtwFrames = 100.0f, 
												int p_NumOfLoops = 1, 
												DWORD p_RenderFlag = D3DXSPRITE_ALPHABLEND | D3DXSPRITE_OBJECTSPACE , 
												D3DXVECTOR3& p_RectOffset = D3DXVECTOR3(0,0,0)
												);

	void						registerSprites(
												LPDIRECT3DDEVICE9	p_Device, 
												string &p_StripeName, 
												string &p_TextureName, 
												int p_TextureWidth, 
												int p_TextureHeight, 
												int p_NOfHorizontalFrames, 
												int p_NOfVerticalFrames 
												);

	map<std::string, SpriteLayout*>			m_SpriteLayouts;

	static SpriteManager*					getSingleton();
};
