
#pragma once
#include <d3dx9.h>
#include <iostream>
class Stats
{
protected:
	Stats(LPDIRECT3DDEVICE9 p_Device);
public:
	~Stats();

	void onLostDevice();
	void onResetDevice();

	void updatePhyTime ( DWORD p_Time )			{	m_PhyTime += (float)p_Time;		};
	void updateRenderTime ( DWORD p_Time )		{	m_RenderTime += (float)p_Time;		};
	void updateParticleTime ( DWORD p_Time )	{	m_ParticleTime += (float)p_Time;	};
	void updateNumOfFrame(DWORD p_NOfFrame = 1)	{	m_NumOfFrame += (float)p_NOfFrame;	};
	void addParticles (unsigned int p_NOfParticles){	m_NumOfParticles += p_NOfParticles; }
	void subParticles (unsigned int p_NOfParticles){	m_NumOfParticles -= p_NOfParticles; }
	void addRenderObj (unsigned int p_NOfPhy){	m_NumOfRenderObjects += p_NOfPhy; }
	void subRenderObj (unsigned int p_NOfPhy){	m_NumOfRenderObjects -= p_NOfPhy; }
	void display();

	static void create(LPDIRECT3DDEVICE9 p_Device);
	static Stats* getSingleton();

	int		m_NumOfRenderObjects;
private:
	// Prevent copying
	Stats(const Stats& rhs);
	Stats& operator=(const Stats& rhs);
	
private:
	ID3DXFont* m_Font;

	float	m_NumOfFrame;

	float	m_LastRun;

	float	m_PhyTime;
	float	m_RenderTime;
	float	m_ParticleTime;

	int		m_NumOfParticles;		

};
