#pragma once
//#ifndef __TOOLS__
//#define __TOOLS__
#include <windows.h>
#include <d3dx9.h>
#include <iostream>
#include <fstream>
#include <ctime>
#include <string>
#include <vector>
#include <conio.h>

using std::ofstream;
using std::string;
using namespace std;

//most critic debug info
#ifndef	DEBUG_LEVEL_1
#define	DEBUG_LEVEL_1
#endif

#ifndef	DEBUG_LEVEL_2
#define	DEBUG_LEVEL_2
#endif
//leas critic debug info, last release
#ifndef	DEBUG_LEVEL_3
#define	DEBUG_LEVEL_3
#endif

typedef struct _RECTF
{
	float	top;
	float	bottom;
	float	left;
	float	right;
}RECTF;

namespace Tools
{
	#define GRAD2DEGREE(x)  ((float)x * 0.01745329252f)

	void LOG(string message, bool showOnScreen = false );
	void CloseLOGFile();
	ofstream* GetLogFile();
	float rnd( float fMin = 0.0f, float fMax= 100.0f );
	inline DWORD FtoDW( FLOAT f ) { return *((DWORD*)&f); }
	float fastSqrt( float number );
	inline float getVectorLengthSQ(D3DXVECTOR3 &p_Vector)
	{
		return (p_Vector.x * p_Vector.x + 
				p_Vector.y * p_Vector.y + 
				p_Vector.z * p_Vector.z );
	}
	inline float getVectorLength(D3DXVECTOR3 &p_Vector)
	{
		return fastSqrt(getVectorLengthSQ(p_Vector));
	}

	void pushRenderState( LPDIRECT3DDEVICE9 p_Device, D3DRENDERSTATETYPE p_State );
	void popRenderState( LPDIRECT3DDEVICE9 p_Device, int p_NumOfState = 1 );
	int searchDirectory(std::vector<std::string> &refvecFiles,
						const std::string        &refcstrRootDirectory,
						const std::string        &refcstrExtension,
						bool                     bSearchSubdirectories);
	LPDIRECT3DDEVICE9	getDevice();
	void				setDevice(LPDIRECT3DDEVICE9 p_Device);

};
namespace GameVariables
{
	string&	getVariable(string &p_VariableName);
	int		getInt(string &p_VariableName);
	float	getFloat(string &p_VariableName);
};

